package eu.mikroskeem.uurimustoo.algoritmidetest.compressors;

import lombok.Getter;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * @author Mark Vainomaa
 */
public class CompressZip extends AbstractCompressor {
    @Getter private final String name = "ZIP";

    @Override
    public void pipe0(InputStream inputStream, OutputStream outputStream) throws IOException {
        try(ZipOutputStream out = new ZipOutputStream(outputStream)){
            ZipEntry ze = new ZipEntry("Test.class");
            out.putNextEntry(ze);
            byte[] buf = new byte[8192];
            int s;
            while((s = inputStream.read()) != -1){
                out.write(buf, 0, s);
            }
            out.closeEntry();
            out.finish();
        }
    }

    @Override
    public OutputStream pipe(OutputStream outputStream) throws IOException {
        throw new UnsupportedOperationException("See void pipe0()");
    }
}
